*************************************************************************
*   25.11.2001    V.A.Ilyin                                             *
*************************************************************************
*      Running ALPHAS                                                   *
*                                                                       *
*   Quark masses thresholds are matched at                              *
*        Mc=1.3 GeV, Mb=4.3 GeV   (MS-bar masses)                       *
*     and Mtop=175 GeV                                                  *
*                                                                       *
*   Input: DSCALE = QCD scale in GeV                                    *
*          QCDL5 =  Lambda in GeV at NF=5                               *
*          NL = 1 (LO), 2(NLL)                                          *
*************************************************************************
      DOUBLE PRECISION FUNCTION ALPHAS2(DSCALE,QCDL5,NL)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /QCDPAR/ QCDLF(6),NNL
      COMMON /BETA/ B0(6),B1(6)
      LOGICAL FIRST
      DATA FIRST/.TRUE./
      SAVE

      IF ((FIRST).OR.(QCDL5.NE.QCDLF(5)).OR.(NNL.NE.NL)) THEN
         NNL = NL
         QCDLF(5) = QCDL5
         PI4=16.0D0*ATAN(1.d0)
         DO 20 NFF=3,6
           B0(NFF)=11.0- 2.0/3.0*NFF
           B1(NFF)=51.0-19.0/3.0*NFF
20       CONTINUE
         XMC = 1.3d0
         XMB = 4.3d0
         XMTOP = 175.d0
* matching t-quark threshold
         QCDLF(6)=TONFB(QCDLF(5),XMTOP,6)
* matching b-quark threshold 
         QCDLF(4)=TONF(QCDLF(5),XMB,5)
* matching c-quark threshold 
         QCDLF(3)=TONF(QCDLF(4),XMC,4)
         FIRST=.FALSE.
      ENDIF

      IF   (DSCALE .GT. XMTOP) THEN
          NF = 6
      ELSEIF (DSCALE .GT. XMB) THEN
          NF = 5
      ELSEIF (DSCALE .GT. XMC) THEN
          NF = 4
      ELSE
          NF = 3
      ENDIF

c...LO 
      BETA0 = B0(NF)
      RL = 2.d0*LOG(DSCALE/QCDLF(NF))
      ALPHAS2 = PI4/(BETA0*RL)
c...NLL 
      IF (NNL.GT.1) THEN
        BETA1 = B1(NF)
        ALPHAS2 = ALPHAS2*(1-2*BETA1/BETA0**2*LOG(RL)/RL )
      ENDIF

      RETURN
      END

****************************************************
*  matching  Lambda_QCD   to lower NF=4,5          *      
****************************************************
      REAL*8 FUNCTION TONF(QCDL,XMQ,NF)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /BETA/ B0(6),B1(6)
      COMMON /QCDPAR/ QCDLF(6),NNL
      SAVE

      RL = LOG(XMQ/QCDL)
      B10N  = B1(NF)/B0(NF)
      B10N1 = B1(NF-1)/B0(NF-1)

      IF (NNL.GT.1) THEN
        XEXP1 = (B10N-B10N1)*LOG(2*RL)-B10N1*LOG(B0(NF)/B0(NF-1))+
     &          (B10N*(B10N-B10N1)*LOG(2.d0*RL)+B10N**2-B10N1**2)
     &          /(B0(NF)*RL)
      ELSE
        XEXP1 = 0d0
      ENDIF

        TONF = QCDL*EXP(-1/B0(NF-1)
     &   *((B0(NF)-B0(NF-1))*RL+XEXP1-(7.0/18.0)/(B0(NF)*RL)
     &    ))

      RETURN
      END

****************************************************
*   get Lambda_QCD(NF+1) back  from  QCDLF(NF)         *      
****************************************************
      REAL*8 FUNCTION TONFB(QCDL,XMQ,NF)
      IMPLICIT REAL*8(A-H,O-Z)

      XLAM = QCDL/2d0
10    CONTINUE
        XLAMx = TONF(XLAM,XMQ,NF)
        EPS = XLAMx-QCDL
        IF (ABS(EPS).GT.1.d-4) THEN
           XLAM = XLAM - EPS/2d0
        ELSE
           TONFB = XLAM
           GOTO 20
        ENDIF
      GOTO 10

20    RETURN
      END
