******************************************************************
*  Part of CPYTH package, interface between COMPHEP and PYTHIA   *
*		    Monte-Carlo generators			 *
******************************************************************
*  authors:  S.Balatenyshev,A.Sherstnev 			 *
*  version:  2.0.01						 *
*  date:    28.07.2002  					 *
******************************************************************

**************************************************
*                    FUNCTION                    *
*         Length of the CHARACTER string         *
**************************************************
      INTEGER FUNCTION STRLEN(STR)
	CHARACTER STR*(*)
	INTEGER I
	
	do i=500,1,-1
	  IF(str(i:i).gt.' ') THEN
	    STRLEN=i
	    RETURN
	  endif	
	ENDDO
      END

*****************************************************
*                   FUNCTION                        *
* Conversion of CHARACTER string to INTEGER number  *
*****************************************************
      INTEGER FUNCTION ATOI(str,strlen)
	INTEGER minus,temp,i,strlen
	CHARACTER str*(*)
	
c	write(*,*)'str=',str,';'
	minus=1
	temp=0
	do i=1,strlen
c	write(*,*)'str(',i,')=',str(i:i),', temp=',temp
	  IF(str(i:i).eq.'-') THEN
	    minus=-1
	  ELSEIF(str(i:i).eq.'1') THEN
	    temp=temp*10+1
	  ELSEIF(str(i:i).eq.'2') THEN
	    temp=temp*10+2
	  ELSEIF(str(i:i).eq.'3') THEN
	    temp=temp*10+3
	  ELSEIF(str(i:i).eq.'4') THEN
	    temp=temp*10+4
	  ELSEIF(str(i:i).eq.'5') THEN
	    temp=temp*10+5
	  ELSEIF(str(i:i).eq.'6') THEN
	    temp=temp*10+6
	  ELSEIF(str(i:i).eq.'7') THEN
	    temp=temp*10+7
	  ELSEIF(str(i:i).eq.'8') THEN
	    temp=temp*10+8
	  ELSEIF(str(i:i).eq.'9') THEN
	    temp=temp*10+9
	  ELSEIF(str(i:i).eq.'0') THEN
	    temp=temp*10
	  ELSEIF(str(i:i).eq.' ') THEN
	    temp=temp*1
	  ELSE
	    ATOI=temp*minus
	    RETURN
	  ENDIF
	ENDDO
	ATOI=temp*minus	
	RETURN
      END
      
*****************************************************
*                   FUNCTION                        *
* Conversion of CHARACTER string to real*8 number   *
*****************************************************
      REAL*8 FUNCTION ATOF(str)
	INTEGER paw, epaw,minus,eminus
	CHARACTER*20 str
	
	ATOF=0	
	flag=0
	paw=0
	epaw=0
	minus=1
	eminus=1
	
	DO i=1,20	
	  IF(str(i:i).eq.".") flag=1
	  IF(str(i:i).eq."E".or.str(i:i).eq."e") flag=2
	  IF(str(i:i).eq."-".and.flag.eq.0) minus=-1
	  IF(str(i:i).eq."-".and.flag.eq.2) eminus=-1
	
	  IF(str(i:i).eq."1".and.flag.eq.0) ATOF=ATOF*10+1
	  IF(str(i:i).eq."2".and.flag.eq.0) ATOF=ATOF*10+2
	  IF(str(i:i).eq."3".and.flag.eq.0) ATOF=ATOF*10+3
	  IF(str(i:i).eq."4".and.flag.eq.0) ATOF=ATOF*10+4
	  IF(str(i:i).eq."5".and.flag.eq.0) ATOF=ATOF*10+5
	  IF(str(i:i).eq."6".and.flag.eq.0) ATOF=ATOF*10+6
	  IF(str(i:i).eq."7".and.flag.eq.0) ATOF=ATOF*10+7
	  IF(str(i:i).eq."8".and.flag.eq.0) ATOF=ATOF*10+8
	  IF(str(i:i).eq."9".and.flag.eq.0) ATOF=ATOF*10+9
	  IF(str(i:i).eq."0".and.flag.eq.0) ATOF=ATOF*10
	
	  IF(str(i:i).eq."1".and.flag.eq.1) THEN 
	    paw=paw+1
	    ATOF=ATOF*10+1	
	  ENDIF
	
	  IF(str(i:i).eq."2".and.flag.eq.1) THEN 
	    paw=paw+1
	    ATOF=ATOF*10+2
	  ENDIF
	
	  IF(str(i:i).eq."3".and.flag.eq.1) THEN 
	    paw=paw+1
	    ATOF=ATOF*10+3
	  ENDIF
	
	  IF(str(i:i).eq."4".and.flag.eq.1) THEN 
	    paw=paw+1
	    ATOF=ATOF*10+4
	  ENDIF
	
	  IF(str(i:i).eq."5".and.flag.eq.1) THEN 
	    paw=paw+1
	    ATOF=ATOF*10+5
	  ENDIF
	
	  IF(str(i:i).eq."6".and.flag.eq.1) THEN 
	    paw=paw+1
	    ATOF=ATOF*10+6
	  ENDIF
	
	  IF(str(i:i).eq."7".and.flag.eq.1) THEN 
	    paw=paw+1
	    ATOF=ATOF*10+7
	  ENDIF
	
	  IF(str(i:i).eq."8".and.flag.eq.1) THEN 
	    paw=paw+1
	    ATOF=ATOF*10+8
	  ENDIF
	
	  IF(str(i:i).eq."9".and.flag.eq.1) THEN 
	    paw=paw+1
	    ATOF=ATOF*10+9
	  ENDIF
	
	  IF(str(i:i).eq."0".and.flag.eq.1) THEN
	    paw=paw+1
	    ATOF=ATOF*10
	  ENDIF
	
	  IF(str(i:i).eq."1".and.flag.eq.2) epaw=epaw*10+1
	  IF(str(i:i).eq."2".and.flag.eq.2) epaw=epaw*10+2
	  IF(str(i:i).eq."3".and.flag.eq.2) epaw=epaw*10+3
	  IF(str(i:i).eq."4".and.flag.eq.2) epaw=epaw*10+4
	  IF(str(i:i).eq."5".and.flag.eq.2) epaw=epaw*10+5
	  IF(str(i:i).eq."6".and.flag.eq.2) epaw=epaw*10+6
	  IF(str(i:i).eq."7".and.flag.eq.2) epaw=epaw*10+7
	  IF(str(i:i).eq."8".and.flag.eq.2) epaw=epaw*10+8
	  IF(str(i:i).eq."9".and.flag.eq.2) epaw=epaw*10+9
	  IF(str(i:i).eq."0".and.flag.eq.2) epaw=epaw*10  
	ENDDO
	
	ATOF=ATOF/(10.**paw)	
	ATOF=ATOF*minus
	
	IF(eminus.eq.-1.and.flag.eq.2) THEN 
	  ATOF=ATOF/(10.**epaw)
	ELSE 
	  ATOF=ATOF*(10.**epaw)
	ENDIF
      END

*******************************************************
*                    FUNCTION                         *
* Conversion of INTEGER number into CHARACTER string  *
*******************************************************
*   Input:  ICHR - output string,                     *
*           JJ - INTEGER number under the conversion; *
*   Output: ITOCHR - the CHARACTER string,            *
*             declare ICHR at least as                *
*                CHARACTER*LENINT(JJ)                 *
*******************************************************
      SUBROUTINE ITOA(ICHR,JJ)
      IMPLICIT REAL*8(A-H,O-Z),INTEGER(I-N) 
      CHARACTER ICHR*(*)
      CHARACTER XFMT*10,XCC

      ICHR=' '
      WRITE(XCC,FMT='(I1)') LENINT(JJ)
      XFMT='(I'//XCC//')'
      WRITE(ICHR,FMT=XFMT,ERR=1) JJ

      goto 9000
1     write(*,*) 'Error in ITOCHR.'
      read(*,*)

9000  RETURN
      END

********************************************
*           FUNCTION                       *
*     Length of the INTEGER number         *
********************************************
      INTEGER FUNCTION LENINT(JJ)
      INTEGER K,JJ,LEN
      K=1
10    CONTINUE
      IF (JJ.LT.10**K) THEN
         LEN=K
         GOTO 20
      ENDIF
      K=K+1 
      GOTO 10

20    LENINT=LEN
      RETURN
      END

********************
* make empty string
********************
      FUNCTION EMPTYS(N)
      CHARACTER*(*) EMPTYS
      SAVE

      DO 15 k=1,N
           EMPTYS(k:k)=' '
15    CONTINUE
      RETURN
      END

*******************************
* delete blanks in string
*******************************
      FUNCTION CMPRS(STR)
      CHARACTER*500 STR,XSTR,CMPRS
      CHARACTER*500 EMPTYS
      SAVE

      j=1
      XSTR = EMPTYS(500)
      DO 10 i=1,80
        IF(STR(i:i).ne.' ') THEN
          XSTR(j:j)=STR(i:i)
          j=j+1
        ENDIF
10    CONTINUE
      CMPRS = XSTR
      RETURN
      END

