*************************************************************************
*          Routine to set some physical parameters in PYTHIA            *
*           CompHEP 4.10  -  PYTHIA 6.2 interface                       *
*************************************************************************
*  06.11.99        A.Skachkova,                                         *
*  25.11.2001      Ilyin V.A.                                           *
*************************************************************************
      SUBROUTINE PHPARS
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      COMMON /PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
*...sinW
c      write(*,*) sqrt(PARU(102))
      sinW=0.473
      PARU(102)=sinW**2
                                   
*...masses, widths and width bands (CompHEP default values)

*....Z0 
c      write(*,*) PMAS(23,1)
       PMAS(23,1)=91.1884
c      write(*,*) PMAS(23,2)
       PMAS(23,2)=2.49444
c      write(*,*) PMAS(23,3)
       PMAS(23,3)=10.*PMAS(23,2)

*...W
c      write(*,*) PMAS(24,1)
       PMAS(24,1)=PMAS(23,1)*sqrt(1.-sinW**2)
c      write(*,*) PMAS(24,2)
       PMAS(24,2)=2.08895
c      write(*,*) PMAS(24,3)
       PMAS(24,3)=10.*PMAS(24,2)
       
*...t-quark
c      write(*,*) PMAS(6,1)
       PMAS(6,1)=175.000
c      write(*,*) PMAS(6,2)
       PMAS(6,2)=1.59
c      write(*,*) PMAS(6,3)
       PMAS(6,3)=10.*PMAS(6,2)

*...b-quark (pole mass)
c      write(*,*) PMAS(5,1)
      PMAS(5,1)= 4.620 
*...c-quark (pole mass)
c      write(*,*) PMAS(4,1)
      PMAS(4,1)= 1.420
*...s-quark
c      write(*,*) PMAS(3,1)
      PMAS(3,1)= 0.200
C...   MU   MASS VALUE  
c      write(*,*) PMAS(13,1)
      PMAS(13,1)=  0.1057
C...   TAU LEPTON   MASS VALUE  
c      write(*,*) PMAS(15,1)
       PMAS(15,1)=  1.777    

      RETURN
      END

*************************************************************************
*          Routine to set some physical parameters in HERWIG            *
*           CompHEP 4.10  -  HERWIG 6.5 interface                       *
*************************************************************************
      SUBROUTINE PHYSPARS
*...HERWIG common blocks
      INCLUDE 'HERWIG65.INC'
      SAVE

      DOUBLE PRECISION sinW

*...sinW
      sinW  = 0.473
      SWEIN = sinW**2
                                   
*...masses, widths and width bands (CompHEP default values)
*....Z-boson
      RMASS(200) = 91.1884
      GAMZ = 2.49444

*...W-boson
      RMASS(198) = RMASS(198)*sqrt(1.-sinW**2)
      GAMW       = 2.08895
       
*...t-quark
      RMASS(6) = 175.000
      RLTIM(6) = 6.582121*10**(-25)/1.59

*...b-quark (pole mass)
      RMASS(5) = 4.620 

*...c-quark (pole mass)
      RMASS(4) = 1.420

*...s-quark
      RMASS(3) = 0.200

*...muon mass  
      RMASS(123) =  0.1057

*...tau lepton mass
      RMASS(125)=  1.777    

      RETURN
      END
